unit yupack;

interface

uses Windows, Messages, Classes, Controls, Forms, Graphics,
  ExtCtrls, buttons, stdctrls, menus;

const
    TextAlignments:array [TAlignment] of Word=(dt_Left, dt_Right, dt_Center);

type
    myrgb=record
       r:byte;
       g:byte;
       b:byte;
    end;

    TTextStyle=(tsNone, tsRaised, tsRecessed, taShadow);
    TYuSoftLabel = class(TLabel)
    private
        FPaintOnClick        : Boolean;
        FMouse               : Boolean;
        FTextStyle           : TTextStyle;
        FTextStyleOnMouse    : TTextStyle;
        FTextStyleBuffer     : TTextStyle;
        FBorderColor         : Tcolor;
        FBorderColorBuffer   : Tcolor;
        FBorderColorOnMouse  : Tcolor;
        FBorderWidth         : Byte;
        FBorderWidthOnMouse  : Byte;
        FBorderWidthBuffer   : Byte;
        FShadowWidth         : Byte;
        FShadowWidthOnMouse  : Byte;
        FShadowWidthBuffer   : Byte;
        FShadowColor         : Tcolor;
        FShadowColorOnMouse  : Tcolor;
        FShadowColorBuffer   : Tcolor;
        FOnMouseEnter        : TNotifyEvent;
        FOnMouseLeave        : TNotifyEvent;
        procedure WMSize(var Message: TWMSize); message WM_SIZE;
        procedure Setshadowcolor(value:Tcolor);
        procedure SetshadowcolorOnMouse(value:Tcolor);
        Procedure SetTextStyleOnMouse(value:TTextStyle);
        Procedure SetTextStyle(value:TTextStyle);
        Procedure SetBorderColor(value:Tcolor);
        Procedure SetBorderColorOnMouse(value:Tcolor);
        Procedure SetShadowWidth(value: Byte);
        Procedure SetShadowWidthOnMouse(value: Byte);
        Procedure SetBorderWidth(value: Byte);
        Procedure SetBorderWidthOnMouse(value: Byte);
    protected
        procedure Paint; override;
        procedure CMLButtonDown(var Message: TMessage); message wM_LBUTTONDOWN;
        procedure CMLBUTTONUP(var Message: TMessage); message wM_LBUTTONUP;
        procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
        procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
        procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        procedure DoEnter;
        procedure DoLeave;
    published
        property OnClick;
        property OnDblClick;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        Property Font;
        Property Caption;
        Property BorderColor: Tcolor read FBorderColor write SetBorderColor default clYellow;
        Property OnMouseBorderColor: Tcolor read FBorderColorOnMouse write SetBorderColorOnMouse default clYellow;
        Property BorderWidth: Byte read FBorderWidth write SetBorderWidth default 0;
        Property OnMouseBorderWidth: Byte read FBorderWidthOnMouse write SetBorderWidthOnMouse default 1;
        Property TextStyle: TTextStyle read FTextStyle write SetTextStyle default tsNone;
        Property OnMouseTextStyle: TTextStyle read FTextStyleOnMouse write SetTextStyleOnMouse default tsNone;
        Property ShadowColor : Tcolor read Fshadowcolor write Setshadowcolor default clBtnFace;
        Property OnMouseShadowColor : Tcolor read FshadowcolorOnMouse write SetshadowcolorOnMouse default clBtnFace;
        property ShadowWidth : Byte read FShadowWidth write SetShadowWidth default 1;
        property OnMouseShadowWidth : Byte read FShadowWidthOnMouse write SetShadowWidthOnMouse default 1;
        property OnMouseEnter:TNotifyEvent read  FOnMouseEnter  write FOnMouseEnter;
        property OnMouseLeave:TNotifyEvent read   FOnMouseLeave write FOnMouseLeave;
        property PaintOnClick:Boolean read FPaintOnClick write FPaintOnClick;
  end;

    TYuSoftButton=class(tgraphiccontrol)
    private
           FUpImage        : TBitmap;
           FDownImage      : TBitmap;
           FMouseOverImage : TBitmap;
           FDisabledImage  : TBitmap;
           DrawMOI         : Boolean;
           FStretch        : Boolean;
           FTrans          : Boolean;
           FTransclr       : TColor;
           FOnMouseEnter   : TNotifyEvent;
           FOnMouseLeave   : TNotifyEvent;
           FOnMouseDown    : TMouseEvent;
           FOnMouseUp      : TMouseEvent;
           procedure SetUpImage(Value: tbitmap);
           procedure SetDownImage(Value: tbitmap);
           procedure SetMouseOverImage(Value: tbitmap);
           procedure SetDisabledImage(Value: TBitmap);
           procedure Setstretch(Value:boolean);
           procedure Settrans(Value:boolean);
           procedure Settransclr(Value:tcolor);
           procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
           procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
           procedure paint;override;
    public
           constructor Create(AOwner: TComponent); override;
           destructor destroy; override;
    protected
           FState: TButtonState;
           procedure check;
           procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
            X, Y: Integer); override;
           procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
           X, Y: Integer); override;
    published
           property Stretch:boolean read fstretch write setstretch;
           property UpImage:tbitmap read fupimage write setupimage;
           property TransparentColor:tcolor read ftransclr write settransclr;
           property DownImage:tbitmap read fDownimage write setDownimage;
           property MouseOverImage:tbitmap read fMouseOverImage write setMouseOverImage;
           property DisabledImage:TBitmap read fDisabledImage write SetDisabledImage;
           property Transparent:boolean read ftrans write settrans;
           property OnMouseEnter:TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
           property OnMouseLeave:TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
           property Visible;
           property OnClick;
           property Enabled;
           property OnDblClick;
           property OnMouseDown:TMouseEvent read  FOnMouseDown write  FOnMouseDown;
           property OnMouseMove;
           property OnMouseUp: TMouseEvent read  FOnMouseUp write FOnMouseUp;
           property ShowHint;
    end;



  TYusoftWallpaper=class(tgraphiccontrol)
  protected
    FImage           : TBitmap;
    FTranscolor      : TColor;
    procedure Paint; override;
    procedure SetImage(Value: TBitMap);
    procedure SetTransColor(Value: TColor);
    procedure loaded;override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    property Image    : TBitMap read fImage write SetImage;
    property TransColor: TColor read ftranscolor write SetTransColor;
    property Height default 100;
    property Width  default 100;
    property Visible;
    property Align default alClient;
    property Enabled;
    property ParentShowHint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;


  TYusoftGradientButton = class(tgraphiccontrol)
  private
    FVertical            : Boolean;
    FSColor              : TColor;
    FEColor              : TColor;
    FBevel               : Integer;
    FFlat                : Boolean;
    FSpacing             : Integer;
    Transclr             : TColor;
    Gwidth               : Integer;
    Drawframe            : Boolean;
    FGlyph               : TBitmap;
    FGray                : Boolean;
    FPopupmark           : Boolean;
    FDown                : Boolean;
    FGroupindex          : Integer;
    FAllup               : Boolean;
    FPopupmenu           : TPopupMenu;
    FLayout              : TButtonLayout;
    FMouseEnter          : TNotifyEvent;
    FMouseLeave          : TNotifyEvent;
    FWindowCaption       : Boolean;
    procedure SetSColor(Value: TColor); virtual;
    procedure SetEColor(Value: TColor); virtual;
    procedure Setbevel(Value: Integer);
    procedure SetSpacing(Value: Integer);
    procedure SetFlat(Value: Boolean);
    procedure SetGray(Value: Boolean);
    procedure SetMark(Value: Boolean);
    procedure SetLayout(Value: TButtonlayout);
    procedure SetGlyph(Value: TBitmap);
    procedure SetPopup(Value: TPopupMenu);
    procedure SetDown(Value: Boolean);
    procedure SetGroupIndex(Value:Integer);
    procedure SetAllUp(Value:Boolean);
    procedure InternalPaint(var Buffer:TBitmap);
    procedure Loaded;override;
    procedure Setvertical(Value: Boolean);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected
    FState: TButtonState;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override ;
    procedure CMDialogChar(var Message: TCMDialogChar); message CM_DIALOGCHAR;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
  published
    property LightColor:tcolor read fscolor write setscolor;
    property ShadowColor:tcolor read fecolor write setecolor;
    property Glyph:tbitmap read fglyph write setglyph;
    property DropDownMenu:tpopupmenu read fpopupmenu write setpopup;
    property GrayedInactive:boolean read fgray write setgray default false;
    property Caption;
    property Layout:tbuttonlayout read flayout write setlayout;
    property BevelWidth:integer read fbevel write setbevel default 1;
    property Font;
    property Down:boolean read fdown write setdown stored true default false;
    property GroupIndex:integer read fgroupindex write setgroupindex;
    property AllowAllUp:boolean read fallup write fallup stored true default false;
    property Flat:boolean read fflat write setflat default false;
    property MarkDropDown:boolean read fpopupmark write setmark default true;
    property Spacing:Integer read fspacing write setspacing default 1;
    property Vertical:boolean read fvertical write setvertical;
    property WindowCaption:Boolean read FWindowCaption write FWindowCaption;
    property OnMouseEnter:TNotifyEvent read FMouseEnter write FMouseEnter;
    property OnMouseLeave:TNotifyEvent read FMouseLeave write FMouseLeave;
    property Enabled;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property ShowHint;
    property ParentFont;
  end;



const PaletteMask = $02000000;
procedure DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer;
  Bitmap: TBitmap; TransparentColor: TColor);
procedure DrawBitmapRectTransparent(Dest: TCanvas; DstX, DstY: Integer;
  SrcRect: TRect; Bitmap: TBitmap; TransparentColor: TColor);
procedure StretchBitmapRectTransparent(Dest: TCanvas; DstX, DstY, DstW,
  DstH: Integer; SrcRect: TRect; Bitmap: TBitmap; TransparentColor: TColor);
procedure mygrayedbmp(var bmp1:tbitmap;const c1,c2:tcolor);
procedure myDrawButtonFace(Canvas: TCanvas; const Client: TRect;
  BevelWidth: Integer; IsDown:boolean;c1,c2:tcolor);
procedure Register;
implementation
{Note:
If you uses YuPack in
commercial application
you must include information
about Yupack author
(Roman Yugov)
}
procedure Register;
begin
   RegisterComponents('YuSoft', [TYuSoftButton]);
   RegisterComponents('YuSoft', [TYuSoftLabel]);
   RegisterComponents('YuSoft', [TYuSoftWallpaper]);
   RegisterComponents('YuSoft', [TYuSoftGradientButton]);
end;
procedure TYuSoftLabel.CMTextChanged(var Message: TMessage);
begin
  paint;
end;


procedure TYuSoftLabel.SetBorderColor(value:Tcolor);
Begin
  if FBorderColor <> value then
   Begin
    FBorderColor := value;
    invalidate;
   end;
End;

procedure TYuSoftLabel.SetBorderColorOnMouse(value:Tcolor);
Begin
  if FBorderColorOnMouse <> value then
   Begin
    FBorderColorOnMouse := value;
    if not (csDesigning in ComponentState ) then invalidate;
   end;
End;


procedure TYuSoftLabel.SetBorderWidth(value:Byte);
Begin
   if FBorderWidth <> value then
     Begin
          FBorderWidth := value;
          Invalidate;
     end;
End;

procedure TYuSoftLabel.SetBorderWidthOnMouse(value:Byte);
Begin
  if (value in [0..9]) then
    begin
         if FBorderWidthOnMouse <> value then
           Begin
                FBorderWidthOnMouse := value;
                if not (csDesigning in ComponentState) then Invalidate;
           end;
    end;
End;


procedure TYuSoftLabel.Setshadowcolor(value:Tcolor);
begin
     if FshadowColor <> value then
       begin
            FshadowColor := value;
            invalidate;
       end;
end;

procedure TYuSoftLabel.SetshadowcolorOnMouse(value:Tcolor);
begin
     if FshadowColorOnMouse <> value then
       begin
            FshadowColorOnMouse := value;
            if not (csDesigning in ComponentState) then invalidate;
       end;
end;


procedure TYuSoftLabel.SetShadowWidth(value: Byte);
Begin
     if (value in [0..9]) then
        if FShadowWidth <> value then
          begin
               FShadowWidth := value;
               invalidate;
          end;
end;

procedure TYuSoftLabel.SetShadowWidthOnMouse(value: Byte);
Begin
     if (value in [0..9]) then
       if FShadowWidthOnMouse <> value then
         begin
              FShadowWidthOnMouse := value;
              if not (csDesigning in ComponentState) then Invalidate;
         end;
end;

procedure TYuSoftLabel.SetTextStyle(value:TTextStyle);
begin
     If FTextStyle <> value then
       begin
            FTextStyle := value;
            Invalidate;
       end;
end;
procedure TYuSoftLabel.SetTextStyleOnMouse(value:TTextStyle);
begin
     If FTextStyleOnMouse <> value then
       begin
            FTextStyleOnMouse := value;
            if not (csDesigning in ComponentState) then Invalidate;
       end;
end;


constructor TYuSoftLabel.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     ControlStyle:=ControlStyle-[csOpaque];
     FPaintOnClick:=False;
     FBorderWidth:=0;
     FBorderColor := ClYellow;
     FBorderWidthOnMouse:=1;
     FBorderColorOnMouse := ClYellow;
     FTextStyle:=tsNone;
     FShadowColor := clbtnshadow;
     FShadowWidth := 1;
     FTextStyleOnMouse:=tsNone;
     FShadowColorOnMouse := clbtnshadow;
     FShadowWidthOnMouse := 1;
     Cursor:=crHandPoint;
     Font.Name := 'Arial';
     Font.size := 20;
     Width := 180;
     Height := 30;
end;

destructor TYuSoftLabel.Destroy;
begin
    inherited Destroy;
end;


procedure TYuSoftLabel.WMSize(var Message: TWMSize);
var
     W, H: Integer;
begin
     inherited;
     W := Width;
     H := Height;
     if (W <> Width) or (H <> Height) then
        inherited SetBounds(Left, Top, W, H);
     Message.Result := 0;
end;

procedure TYuSoftLabel.CMMouseEnter(var Message: TMessage);
begin
     inherited;
     DoEnter;
     if Assigned (FOnMouseEnter) then FOnMouseEnter(Self);
end;
procedure TYuSoftLabel.DoEnter;
begin
     FMouse:=True;
     FBorderWidthBuffer:=FBorderWidth;
     FBorderColorBuffer:=FBorderColor;
     FTextStyleBuffer:=FTextStyle;
     FShadowColorBuffer:=FShadowColor;
     FShadowWidthBuffer:=FShadowWidth;
     FTextStyle:=FTextStyleOnMouse;
     FBorderWidth:=FBorderWidthOnMouse;
     FBorderColor:=FBorderColorOnMouse;
     FShadowWidth:=FShadowWidthOnMouse;
     FShadowColor:=FShadowColorOnMouse;
     if Enabled then
       begin
         if Transparent then Invalidate  else Paint;
       end;
end;

procedure TYuSoftLabel.CMMouseLeave(var Message: TMessage);
begin
     inherited;
     DoLeave;
     if Assigned (FOnMouseLeave) then FOnMouseLeave(Self);
end;

procedure TYuSoftLabel.DoLeave;
begin
     FMouse:=False;
     FTextStyle:=FTextStyleBuffer;
     FBorderWidth:=FBorderWidthBuffer;
     FBorderColor:=FBorderColorBuffer;
     FShadowWidth:=FShadowWidthBuffer;
     FShadowColor:=FShadowColorBuffer;
     if Enabled then
       begin
         if Transparent then Invalidate  else Paint;
       end;
end;



procedure TYuSoftLabel.Paint;
var
ULColor, LRColor:TColor;
TempRect, R:TRect;
Flags:Word;
Bmp:TBitmap;
TempVarX, TempVarY:Byte;
begin
     Bmp:=TBitmap.Create;
     BMP.Width:=Width;
     BMP.Height:=Height;

     with BMP.Canvas do
       begin
            Brush.Color:=Self.Color;
            Brush.Style:=bsSolid;
            FillRect(Self.ClientRect);


            Brush.Style:=bsClear;
            R:=Rect(0,0,width, height);
            Flags:=dt_ExpandTabs or TextAlignments[Alignment];

            if WordWrap then Flags:=Flags or dt_WordBreak;
            if Not ShowAccelChar then Flags:=Flags or dt_NoPrefix;
            Font:=Self.Font;
            if Enabled then
              begin
                if FTextStyle in [tsRecessed, tsRaised] then
                  begin
                    case FTextStyle of
                      tsRaised:
                        begin
                          UlColor:=clBtnHighLight;
                          LrColor:=clBtnShadow;
                        end;
                      tsRecessed:
                        begin
                          LrColor:=clBtnHighLight;
                          UlColor:=clBtnShadow;
                        end;
                      end;
                    TempRect:=R;
                    OffsetRect(TempRect,1,1);
                    Font.Color:=LRColor;
                    DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                    TempRect:=R;
                    OffsetRect(TempRect,-1,-1);
                    Font.Color:=ULColor;
                    DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                  end
                 else
                  begin
                    if FTextStyle=taShadow then
                      begin
                        TempRect:=R;
                        Font.Color:=FShadowColor;
                        OffsetRect(TempRect,FShadowWidth, FShadowWidth);
                        DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                      end;
                  end;
                end;
            if (FBorderWidth>0) and (Enabled) then
              begin
                Brush.Style := bsClear;
                Font.Color := FBorderColor;
                for TempVarX:=1 to FBorderWidth do
                  for TempVarY:=1 to  FBorderWidth do
                   begin
                     TempRect:=R;
                     OffsetRect(TempRect,TempVarX,TempVarY);
                     DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                     TempRect:=R;
                     OffsetRect(TempRect,TempVarX,-TempVarY);
                     DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                     TempRect:=R;
                     OffsetRect(TempRect,-TempVarX,TempVarY);
                     DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                     TempRect:=R;
                     OffsetRect(TempRect,-TempVarX,-TempVarY);
                     DrawText(Handle,PChar(Caption),-1, TempRect,Flags);
                  end;
                end;

            Font.Color:=Self.Font.Color;
            if not Enabled then Font.Color:=clGrayText;
            DrawText(Handle,PChar(Caption),-1, R,Flags);

      end;
    if Transparent then   DrawBitmapTransparent(canvas,0,0, bmp, Self.Color)
     else BitBlt(canvas.handle,0,0,width,height,bmp.canvas.handle,0,0,srccopy);
    BMP.Free;
end;

procedure TYuSoftLabel.CMLButtonDown(var Message: TMessage);
begin
    if FPaintOnClick then
       begin
           FTextStyle:=FTextStyleBuffer;
           FBorderWidth:=FBorderWidthBuffer;
           FBorderColor:=FBorderColorBuffer;
           FShadowWidth:=FShadowWidthBuffer;
           FShadowColor:=FShadowColorBuffer;
           if Transparent then invalidate
               else paint;
       end;
    inherited;
end;

procedure TYuSoftLabel.CMLButtonUP(var Message: TMessage);
begin
    if FPaintOnClick then
       begin
         FTextStyle:=FTextStyleOnMouse;
         FBorderWidth:=FBorderWidthOnMouse;
         FBorderColor:=FBorderColorOnMouse;
         FShadowWidth:=FShadowWidthOnMouse;
         FShadowColor:=FShadowColorOnMouse;
         if Transparent then invalidate
           else paint;
       end;
     inherited;
end;



constructor TYuSoftbutton.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     ControlStyle:=ControlStyle+[csOpaque];
     Width:=50;
     Height:=50;
     FUpImage:=TBitmap.Create;
     FDownImage:=TBitmap.Create;
     FMouseOverImage:=TBitmap.Create;
     FDisabledImage:=TBitmap.Create;
     FStretch:=False;
     FTransclr:=clWhite;
     FTrans:=False;
end;

destructor TYuSoftbutton.destroy;
begin
     FUpimage.Free;
     FDownimage.Free;
     FMouseoverimage.Free;
     FDisabledImage.Free;
     inherited destroy;
end;



procedure TYuSoftbutton.setstretch(value: boolean);
begin
 if value<>fstretch then
   begin
    fstretch:=value;
    invalidate;
   end;
end;

procedure TYuSoftbutton.settransclr(value:tcolor);
begin
     if value<>ftransclr then
        begin
          ftransclr:=value;
          invalidate;
        end;
end;

procedure TYuSoftbutton.settrans(value: boolean);
begin
if value<>ftrans then
   begin
     ftrans:=value;
     if ftrans then controlstyle:=controlstyle - [csopaque]
       else  controlstyle:=controlstyle +[csopaque];
     invalidate;
   end;
end;

procedure TYuSoftbutton.check;
begin
  if fupimage.width>0 then
     begin
      if fdownimage.width<1 then fdownimage.assign(fupimage);
      if fmouseoverimage.width<1 then fmouseoverimage.assign(fupimage);
      if FDisabledImage.width<1 then FDisabledImage.assign(fupimage);
    end;
end;

procedure TYuSoftbutton.setupimage(value: tbitmap);
begin
     fupimage.assign(value);
     check;
     invalidate;
end;

procedure TYuSoftbutton.setDownimage(value: tbitmap);
begin
     fDownimage.assign(value);
     invalidate;
end;

procedure TYuSoftbutton.setmouseoverimage(value: tbitmap);
begin
     fmouseoverimage.assign(value);
end;

procedure TYuSoftbutton.SetDisabledImage(value: tbitmap);
begin
     FDisabledImage.assign(value);

end;
procedure TYuSoftbutton.CMMouseEnter(var Message: TMessage);
begin
     drawMOI:=True;
     if FTrans then invalidate
       else paint;
     if Assigned(FOnMouseEnter) then FOnMouseEnter(Self);
end;

procedure TYuSoftbutton.CMMouseLeave(var Message: TMessage);
begin
     drawMOI:=False;
     if FTrans then invalidate
       else paint;
     if Assigned(FOnMouseLeave) then FOnMouseLeave(Self);
end;


procedure  TYuSoftbutton.paint;
var
    buffer:tbitmap;
    _rect:trect;
begin
     if (downimage.width<1) or (mouseoverimage.width<1) then check;
     buffer:=tbitmap.create;
     buffer.width:=width;buffer.height:=height;

     _rect:=clientrect;
     if not ftrans then
        begin
             buffer.canvas.brush.color:=(parent as twincontrol).brush.color;
             buffer.canvas.fillrect(_rect);
        end
       else
        begin
            buffer.canvas.brush.color:=Ftransclr;
            buffer.canvas.fillrect(_rect);
        end;

        if (upimage.width>1) then
           begin
                if not ftrans then
                   begin
                     if not Enabled then  buffer.canvas.draw(0,0,FDisabledImage)
                       else
                         begin
                           if fstate=bsdown  then
                             begin
                               if not fstretch then buffer.canvas.draw(0,0,fDownImage)
                                else buffer.canvas.stretchdraw(_rect,fDownImage);
                             end
                            else
                             if not fstretch then
                               begin
                                 if drawMOI then buffer.canvas.draw(0,0,fMouseOverImage)
                                  else if not drawmoi then buffer.canvas.draw(0,0,fUpImage);
                                end
                               else
                                begin
                                  if drawMOI then buffer.canvas.stretchdraw(_rect,mouseoverimage)
                                   else if not drawmoi then buffer.canvas.stretchdraw(_rect,upimage);
                                end;
                         end
                   end
                  else
                   begin
                     if not Enabled then  DrawBitmapTransparent(buffer.Canvas, 0, 0, FDisabledImage, ftransclr )
                      else
                        begin
                          if fstate=bsdown  then
                            begin
                              if not fstretch then DrawBitmapTransparent(buffer.Canvas, 0, 0, downimage, ftransclr )
                               else StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,downimage,ftransclr);
                            end
                           else
                            if not fstretch then
                              begin
                                if drawMOI then DrawBitmapTransparent(buffer.Canvas, 0, 0, mouseoverimage, ftransclr )
                                 else if not drawmoi then DrawBitmapTransparent(buffer.Canvas, 0, 0, upimage, ftransclr )
                              end
                             else
                              begin
                                if drawMOI then StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,mouseoverimage,ftransclr)
                                 else if not drawmoi then StretchBitmapRectTransparent(buffer.canvas,0,0,width,height,_rect,upimage,ftransclr);
                              end;
                        end;
                   end;
                end
             else
                 begin
                      buffer.canvas.brush.color:=clbtnface;
                      buffer.canvas.fillrect(clientrect);
                 end;
       if FTrans then   DrawBitmapTransparent(canvas,0,0, buffer, Ftransclr)
         else
  BitBlt(Canvas.Handle,0,0,Width,Height,Buffer.Canvas.Handle,0,0,SRCCOPY);
  Buffer.Free;
end;

procedure TYuSoftbutton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseDown(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
    begin
      FState := bsDown;
      Refresh;
      if Assigned (FOnMouseDown) then FOnMouseDown(Self, Button, Shift, X, Y);
    end;
end;

procedure TYuSoftbutton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  if (Button = mbLeft) and Enabled then
  begin
    fstate:= bsUp;
    refresh;
    if Assigned (FOnMouseUp) then FOnMouseUp(Self, Button, Shift, X, Y);
  end;

end;


constructor TYusoftWallpaper.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  controlstyle:=controlstyle +[csopaque];
  FImage:=TBitMap.Create;
  ftranscolor:=clblack;
  width:=100; height:=100;
  Align:=alClient;
end;

destructor TYusoftWallpaper.Destroy;
begin
  FImage.Free;
  inherited Destroy;
end;

procedure TYusoftWallpaper.SetImage(Value: tbitmap);
begin
  if Assigned(Value) then
  begin
    ftranscolor := Value.TransparentColor;
    fimage.Assign(Value);
    canvas.brush.color:=(parent as twincontrol).brush.color;
    canvas.rectangle(0,0,width,height);
    invalidate;
  end
  else
  begin
    FImage.Height := 0;
    FImage.Width  := 0;
    invalidate;
  end;
end;



procedure TYusoftWallpaper.settranscolor(value:tcolor);
begin
if value<>ftranscolor then
   begin
   ftranscolor:=value;
   invalidate;
   end;
end;



procedure TYusoftWallpaper.loaded;
begin
 inherited loaded;
 invalidate;
end;

procedure TYusoftWallpaper.paint;
var
Buffer:TBitmap;
x,y:Integer;
begin
  Buffer:=TBitmap.Create;
  Buffer.Width:=Width;
  Buffer.Height:=Height;
  if FImage.Width>0 then
    begin
      y:=0;
      while y<Height do
        begin
          x:=0;
          while x<Width do
            begin
              BitBlt(Buffer.Canvas.Handle,x,y,FImage.Width,FImage.Height,FImage.Canvas.Handle,0,0,SRCCOPY);
              inc(x,FImage.Width);
            end;
          inc(y,FImage.Height);
        end;
      BitBlt(Canvas.Handle,0,0,Width,Height,Buffer.Canvas.Handle,0,0,SRCCOPY);
    end;
  Buffer.free;
end;




constructor TYusoftGradientButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csclickevents, csCaptureMouse, csOpaque, csDoubleClicks];
  FPopupmenu:=nil;
  Width:=25;
  Height:=25;
  FGroupIndex:=0;
  FDown:=false;
  FAllup:=false;
  FSColor:=clbtnhighlight;
  FEColor:=clbtnshadow;
  FBevel:=1;
  FSpacing:=1;
  FWindowCaption:=False;
  FFlat:=false;
  FPopupmark:=true;
  FLayout:=blglyphTop;
  FGray:=true;
  Drawframe:=true;
  FGlyph:=TBitmap.create;
  FVertical:=false;
end;

destructor TYusoftGradientButton.Destroy;
begin
  FGlyph.free;
  inherited destroy;
end;

procedure TYusoftGradientButton.Loaded;
begin
  inherited loaded;
  Setglyph(FGlyph);
end;

procedure TYusoftGradientButton.SetLayout(Value: TButtonLayout);
begin
  if value<>flayout then
    begin
      flayout:=value;
      invalidate;
    end;
end;

procedure TYusoftGradientButton.Setpopup(value: TPopupMenu);
begin
  FPopupmenu := value;
  if FPopupmark then invalidate;
end;

procedure TYusoftGradientButton.setscolor(value: TColor);
begin
  if value<>FSColor then
    begin
      FSColor:=value;
      invalidate;
    end;
end;


procedure TYusoftGradientButton.SetGray(Value: Boolean);
begin
  if Value<>FGray then
    begin
      FGray:=Value;
      Invalidate;
    end;
end;

procedure TYusoftGradientButton.setdown(value: boolean);
var i: Integer;
otherbutton: TYusoftGradientButton;
begin
	if FDown = value then
   	Exit;
	if FGroupIndex <> 0 then
	begin
          FDown := value;
          invalidate;
          if FDown = True then
          begin
                  for i := 0 to Parent.ControlCount - 1 do
                  begin
                          if Parent.Controls[i] is TYusoftGradientButton then
                          begin
                                  otherbutton := (Parent.Controls[i] as TYusoftGradientButton);
                                  if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex)
                                          and (otherbutton.FDown = True) then
                                  begin
                                          otherbutton.FDown := False;
                                          otherbutton.invalidate;
                                  end
                          end
                  end
          end
  end
end;

procedure TYusoftGradientButton.SetAllUp(Value:Boolean);
var i: Integer;
otherbutton: TYusoftGradientButton;
begin
	FAllUp := value;
	if FGroupIndex <> 0 then
	begin
		for i := 0 to Parent.ControlCount - 1 do
		begin
			if Parent.Controls[i] is TYusoftGradientButton then
			begin
				otherbutton := (Parent.Controls[i] as TYusoftGradientButton);
				if (otherbutton <> Self) and (otherbutton.GroupIndex = GroupIndex) then
					otherbutton.FAllUp := value;
			end
		end
	end
end;

procedure TYusoftGradientButton.SetGroupIndex(Value:Integer);
begin
	if FGroupIndex = value then Exit;
	FGroupIndex := value;
	if (FGroupIndex = 0) and FDown then
	  begin
	    FDown := False;
            invalidate;
	  end;
end;


procedure TYusoftGradientButton.setflat(value: boolean);
begin
  FFlat:=value;
  if value=false then drawframe:=true else drawframe:=false;
  invalidate;
end;

procedure TYusoftGradientButton.setmark(value: boolean);
begin
  if value<>FPopupmark then
    begin
      FPopupmark:=value;
      invalidate;
    end;
end;

procedure TYusoftGradientButton.setglyph(value: tbitmap);
begin
  FGlyph.assign(value);
  if (value<>nil) and (value.height<>0) then
    begin
      fglyph.assign(value);
      transclr:=value.transparentcolor;
    end
  else
    gwidth:=0;
    invalidate;
end;


procedure TYusoftGradientButton.Notification(AComponent: TComponent; Operation:
TOperation);
begin
  if (operation = opRemove) and (AComponent = fpopupmenu) then fpopupmenu := nil;
end;

procedure TYusoftGradientButton.CMDialogChar(var Message: TCMDialogChar);
var pos:tpoint;
begin
	with Message do
		if IsAccel(CharCode, Caption)and Enabled and Visible then
	begin
          getcursorpos(pos);
          pos:=screentoclient(pos);
          Application.ProcessMessages;
	  mousedown(mbleft,[ssleft],pos.x,pos.y);
	  Application.ProcessMessages;
	  mouseup(mbleft,[ssleft],pos.x,pos.y);
	  Application.ProcessMessages;
          Click;
	  Result := 1;
	end;
end;

procedure TYusoftGradientButton.CMMouseEnter(var Message: TMessage);
begin
  DrawFrame:=true;
  if ((FFlat) and (Enabled)) then repaint;
  if Assigned(FMouseEnter) then FMouseEnter(Self);
end;

procedure TYusoftGradientButton.CMMouseLeave(var Message: TMessage);
begin
  if FFlat then DrawFrame:=False else DrawFrame:=True;
  if ((FFlat) and (Enabled)) then Repaint;
  if Assigned(FMouseLeave) then FMouseLeave(Self);
end;

procedure TYusoftGradientButton.CMFontChanged(var Message: TMessage);
begin
  Invalidate;
end;

procedure TYusoftGradientButton.CMTextChanged(var Message: TMessage);
begin
  Invalidate;
end;

procedure TYusoftGradientButton.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
var pos:tpoint;
begin
  inherited MouseDown(Button, Shift, X, Y);
  if ((Button = mbLeft) and (Enabled) and (not FWindowCaption)) then
  begin
      FState := bsDown;
      repaint;
      if fpopupmenu<>nil then
        begin
          Application.ProcessMessages;
          if fflat then DrawFrame:=False else DrawFrame:=True;
          FState := bsup;
          Repaint;
          pos:=ClientToScreen(Point(0, Height));
          fpopupmenu.popup(pos.x,pos.y);
        end;
  end;
end;

procedure TYusoftGradientButton.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited MouseUp(Button, Shift, X, Y);
  if ((Button = mbLeft) and (Enabled) and (not FWindowCaption)) then
    begin
      FState:= bsUp;
      Repaint;
   end;
end;

procedure TYusoftGradientButton.setspacing(value: integer);
begin
  FSpacing:=value;
  invalidate;
end;

procedure TYusoftGradientButton.setbevel(value: integer);
begin
  if fbevel<>value then
   begin
     FBevel:=value;
     invalidate;
   end;
end;

procedure TYusoftGradientButton.setecolor(value: tcolor);
begin
  FEColor:=value;
  Invalidate;
end;

procedure TYusoftGradientButton.internalpaint(var buffer:tbitmap);
var
  _rect  :TRect;
  gleft,gtop,tleft,ttop,mleft,totalh,adjust2:integer;
begin
  tleft:=0;
  ttop:=0;
  gleft:=0;
  gtop:=0;
  mleft:=0;

  buffer.canvas.font:=self.font;
  if FPopupmark AND (FPopupmenu<>nil) then
    adjust2:=4 else adjust2:=0;

  totalh:=FGlyph.height+buffer.canvas.textheight(caption)+2+spacing;

  case layout of
     blglyphtop:   begin
                    tleft:=width div 2 - buffer.canvas.textwidth(caption) div 2-adjust2;
                    ttop:=height div 2 - totalh div 2+fglyph.height+spacing;
                    gleft:=width div 2 - gwidth div 2;
                    gtop:=ttop - fglyph.height -spacing;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2+adjust2 div 2;
                   end;
     blglyphbottom:begin
                    ttop:=height div 2 - totalh div 2;
                    tleft:=width div 2 - buffer.canvas.textwidth(caption) div 2-adjust2;

                    gleft:=width div 2 - gwidth div 2;
                    gtop:=ttop + fglyph.height + spacing;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2+adjust2 div 2;
                   end;
     blglyphleft:  begin
                     if FGlyph.Width>0 then  tleft:=width div 2-buffer.canvas.textwidth(caption) div 2+gwidth div 2+spacing
                       else tleft:=width-buffer.canvas.textwidth(caption)-spacing ;
                    ttop:=height div 2 - buffer.canvas.textheight(caption) div 2;
                    gleft:=tleft-spacing-gwidth;
                    gtop:=height div 2 - fglyph.height div 2;
                    mleft:=tleft+buffer.canvas.textwidth(caption)+2;
                   end;
     blglyphright: begin
                     if FGlyph.Width>0 then  tleft:=width div 2-buffer.canvas.textwidth(caption) div 2-spacing-gwidth div 2
                       else tleft:=spacing;
                    ttop:=height div 2 - buffer.canvas.textheight(caption) div 2;
                    gleft:=width div 2+buffer.canvas.textwidth(caption) div 2+spacing-gwidth div 2;
                    gtop:=height div 2 - fglyph.height div 2;
                    mleft:=tleft-4;
                   end;
     end;

  //drawtext
  with buffer.canvas do
    begin
      _rect:=rect(tleft,ttop,width-bevelwidth-1-adjust2,height);
     brush.style:=bsclear;
     DrawText(Handle, PChar(caption), Length(caption), _Rect, dt_left or dt_noclip) ;
    end;

  if (fglyph<>nil) and (fglyph.height<>0) then
       DrawBitmapTransparent(buffer.Canvas,  gleft, gtop, fglyph, transclr );


   _rect:=clientrect;
   if drawframe AND flat then
     if not((fstate=bsdown) OR down) then
      Frame3D(buffer.Canvas, _rect, lightcolor, shadowcolor, bevelwidth)
   else
      Frame3D(buffer.Canvas, _rect, shadowcolor, lightcolor, bevelwidth);

   if (not flat) and (bevelwidth>0) then
                  myDrawButtonFace(buffer.canvas,clientrect,bevelwidth,
                  fdown or (fstate=bsdown) ,shadowcolor, lightcolor);
end;



procedure TYusoftgradientbutton.setvertical(value: boolean);
begin
  FVertical:=value;
  Repaint;
end;


procedure TYusoftgradientbutton.Paint;
var x:integer;
    _a,_b,_c:myrgb;
    buffer:tbitmap;
begin

  buffer:=tbitmap.create;
  buffer.width:=width;buffer.height:=height;

  _a.r:=getrvalue(colortorgb(fscolor));
  _a.g:=getgvalue(colortorgb(fscolor));
  _a.b:=getbvalue(colortorgb(fscolor));


  _b.r:=getrvalue(colortorgb(fecolor));
  _b.g:=getgvalue(colortorgb(fecolor));
  _b.b:=getbvalue(colortorgb(fecolor));


  buffer.canvas.pen.style:=pssolid;
  buffer.canvas.pen.width:=1;

  if not fvertical then
    for x:=0 to width do
      with buffer.canvas do
        begin
          if _a.r<_b.r then  _c.r:=_a.r+round(((_b.r-_a.r) / width)*x)
            else _c.r:=_a.r-round(((_a.r-_b.r) / width)*x);
          if _a.g<_b.g then   _c.g:=_a.g+round(((_b.g-_a.g) / width)*x)
            else _c.g:=_a.g-round(((_a.g-_b.g) / width)*x);
          if _a.b<_b.b then   _c.b:=_a.b+round(((_b.b-_a.b) / width)*x)
            else _c.b:=_a.b-round(((_a.b-_b.b) / width)*x);
          pen.color:=rgb(_c.r,_c.g,_c.b);
          moveto(x,0);
          lineto(x,height);
       end
      else
       for x:=0 to height do
         with buffer.canvas do
           begin
             if _a.r<_b.r then  _c.r:=_a.r+round(((_b.r-_a.r) / height)*x)
               else _c.r:=_a.r-round(((_a.r-_b.r) / height)*x);
             if _a.g<_b.g then   _c.g:=_a.g+round(((_b.g-_a.g) / height)*x)
               else _c.g:=_a.g-round(((_a.g-_b.g) / height)*x);
             if _a.b<_b.b then   _c.b:=_a.b+round(((_b.b-_a.b) / height)*x)
               else _c.b:=_a.b-round(((_a.b-_b.b) / height)*x);
             pen.color:=rgb(_c.r,_c.g,_c.b);
             moveto(0,x);
             lineto(width,x);
          end;

  internalpaint(buffer);
  bitblt(canvas.handle,0,0,width,height,buffer.canvas.handle,0,0,srccopy);
  buffer.free;
end;

function PaletteColor(Color: TColor): Longint;
begin
  Result := ColorToRGB(Color) or PaletteMask;
end;

procedure StretchBltTransparent(DstDC: HDC; DstX, DstY, DstW, DstH: Integer;
  SrcDC: HDC; SrcX, SrcY, SrcW, SrcH: Integer; Palette: HPalette;
  TransparentColor: TColorRef);
var
  Color: TColorRef;
  bmAndBack, bmAndObject, bmAndMem, bmSave: HBitmap;
  bmBackOld, bmObjectOld, bmMemOld, bmSaveOld: HBitmap;
  MemDC, BackDC, ObjectDC, SaveDC: HDC;
  palDst, palMem, palSave, palObj: HPalette;
begin
  { Create some DCs to hold temporary data }
  BackDC := CreateCompatibleDC(DstDC);
  ObjectDC := CreateCompatibleDC(DstDC);
  MemDC := CreateCompatibleDC(DstDC);
  SaveDC := CreateCompatibleDC(DstDC);
  { Create a bitmap for each DC }
  bmAndObject := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndBack := CreateBitmap(SrcW, SrcH, 1, 1, nil);
  bmAndMem := CreateCompatibleBitmap(DstDC, DstW, DstH);
  bmSave := CreateCompatibleBitmap(DstDC, SrcW, SrcH);
  { Each DC must select a bitmap object to store pixel data }
  bmBackOld := SelectObject(BackDC, bmAndBack);
  bmObjectOld := SelectObject(ObjectDC, bmAndObject);
  bmMemOld := SelectObject(MemDC, bmAndMem);
  bmSaveOld := SelectObject(SaveDC, bmSave);
  { Select palette }
  palDst := 0; palMem := 0; palSave := 0; palObj := 0;
  if Palette <> 0 then begin
    palDst := SelectPalette(DstDC, Palette, True);
    RealizePalette(DstDC);
    palSave := SelectPalette(SaveDC, Palette, False);
    RealizePalette(SaveDC);
    palObj := SelectPalette(ObjectDC, Palette, False);
    RealizePalette(ObjectDC);
    palMem := SelectPalette(MemDC, Palette, True);
    RealizePalette(MemDC);
  end;
  { Set proper mapping mode }
  SetMapMode(SrcDC, GetMapMode(DstDC));
  SetMapMode(SaveDC, GetMapMode(DstDC));
  { Save the bitmap sent here }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, SrcDC, SrcX, SrcY, SRCCOPY);
  { Set the background color of the source DC to the color,         }
  { contained in the parts of the bitmap that should be transparent }
  Color := SetBkColor(SaveDC, PaletteColor(TransparentColor));
  { Create the object mask for the bitmap by performing a BitBlt()  }
  { from the source bitmap to a monochrome bitmap                   }
  BitBlt(ObjectDC, 0, 0, SrcW, SrcH, SaveDC, 0, 0, SRCCOPY);
  { Set the background color of the source DC back to the original  }
  SetBkColor(SaveDC, Color);
  { Create the inverse of the object mask }
  BitBlt(BackDC, 0, 0, SrcW, SrcH, ObjectDC, 0, 0, NOTSRCCOPY);
  { Copy the background of the main DC to the destination }
  BitBlt(MemDC, 0, 0, DstW, DstH, DstDC, DstX, DstY, SRCCOPY);
  { Mask out the places where the bitmap will be placed }
  StretchBlt(MemDC, 0, 0, DstW, DstH, ObjectDC, 0, 0, SrcW, SrcH, SRCAND);
  { Mask out the transparent colored pixels on the bitmap }
  BitBlt(SaveDC, 0, 0, SrcW, SrcH, BackDC, 0, 0, SRCAND);
  { XOR the bitmap with the background on the destination DC }
  StretchBlt(MemDC, 0, 0, DstW, DstH, SaveDC, 0, 0, SrcW, SrcH, SRCPAINT);
  { Copy the destination to the screen }
  BitBlt(DstDC, DstX, DstY, DstW, DstH, MemDC, 0, 0,
    SRCCOPY);
  { Restore palette }
  if Palette <> 0 then begin
    SelectPalette(MemDC, palMem, False);
    SelectPalette(ObjectDC, palObj, False);
    SelectPalette(SaveDC, palSave, False);
    SelectPalette(DstDC, palDst, True);
  end;
  { Delete the memory bitmaps }
  DeleteObject(SelectObject(BackDC, bmBackOld));
  DeleteObject(SelectObject(ObjectDC, bmObjectOld));
  DeleteObject(SelectObject(MemDC, bmMemOld));
  DeleteObject(SelectObject(SaveDC, bmSaveOld));
  { Delete the memory DCs }
  DeleteDC(MemDC);
  DeleteDC(BackDC);
  DeleteDC(ObjectDC);
  DeleteDC(SaveDC);
end;

procedure StretchBitmapTransparent(Dest: TCanvas; Bitmap: TBitmap;
  TransparentColor: TColor; DstX, DstY, DstW, DstH, SrcX, SrcY,
  SrcW, SrcH: Integer);
var
  CanvasChanging: TNotifyEvent;
  Temp: TBitmap;
begin
  if DstW <= 0 then DstW := Bitmap.Width;
  if DstH <= 0 then DstH := Bitmap.Height;
  if (SrcW <= 0) or (SrcH <= 0) then begin
    SrcX := 0; SrcY := 0;
    SrcW := Bitmap.Width;
    SrcH := Bitmap.Height;
  end;
  if not Bitmap.Monochrome then
    SetStretchBltMode(Dest.Handle, STRETCH_DELETESCANS);
  CanvasChanging := Bitmap.Canvas.OnChanging;
  try
    Bitmap.Canvas.OnChanging := nil;
{$IFDEF RX_D3}
    {if Bitmap.HandleType = bmDIB then begin
      Temp := TBitmap.Create;
      Temp.Assign(Bitmap);
      Temp.HandleType := bmDDB;
    end
    else} Temp := Bitmap;
{$ELSE}
    Temp := Bitmap;
{$ENDIF}
    try
      if TransparentColor = clNone then begin
        StretchBlt(Dest.Handle, DstX, DstY, DstW, DstH, Temp.Canvas.Handle,
          SrcX, SrcY, SrcW, SrcH, Dest.CopyMode);
      end
      else begin
{$IFDEF RX_D3}
        if TransparentColor = clDefault then
          TransparentColor := Temp.Canvas.Pixels[0, Temp.Height - 1];
{$ENDIF}
        if Temp.Monochrome then TransparentColor := clWhite
        else TransparentColor := ColorToRGB(TransparentColor);
        StretchBltTransparent(Dest.Handle, DstX, DstY, DstW, DstH,
          Temp.Canvas.Handle, SrcX, SrcY, SrcW, SrcH, Temp.Palette,
          TransparentColor);
      end;
    finally
{$IFDEF RX_D3}
      {if Bitmap.HandleType = bmDIB then Temp.Free;}
{$ENDIF}
    end;
  finally
    Bitmap.Canvas.OnChanging := CanvasChanging;
  end;
end;

procedure StretchBitmapRectTransparent(Dest: TCanvas; DstX, DstY,
  DstW, DstH: Integer; SrcRect: TRect; Bitmap: TBitmap;
  TransparentColor: TColor);
begin
  with SrcRect do
    StretchBitmapTransparent(Dest, Bitmap, TransparentColor,
    DstX, DstY, DstW, DstH, Left, Top, Right - Left, Bottom - Top);
end;

procedure DrawBitmapRectTransparent(Dest: TCanvas; DstX, DstY: Integer;
  SrcRect: TRect; Bitmap: TBitmap; TransparentColor: TColor);
begin
  with SrcRect do
    StretchBitmapTransparent(Dest, Bitmap, TransparentColor,
    DstX, DstY, Right - Left, Bottom - Top, Left, Top, Right - Left,
    Bottom - Top);
end;

procedure DrawBitmapTransparent(Dest: TCanvas; DstX, DstY: Integer;
  Bitmap: TBitmap; TransparentColor: TColor);
begin
  StretchBitmapTransparent(Dest, Bitmap, TransparentColor, DstX, DstY,
    Bitmap.Width, Bitmap.Height, 0, 0, Bitmap.Width, Bitmap.Height);
end;
procedure mygrayedbmp(var bmp1:tbitmap;const c1,c2:tcolor);
var x,y,tmp:integer;
    _c:integer;
    __c:tcolor;
begin
if bmp1.width*bmp1.height>10000 then exit;
//I don't want the button spend hours for this when repainting.
//Anyway, only very dull people will use 100*100 glyphs, hopefully :-)
for x:=0 to bmp1.width do
    for y:=0 to bmp1.height do
        begin
            __c:=bmp1.canvas.pixels[x,y];
            if __c<>bmp1.canvas.pixels[0,0] then
               begin
               _c:=colortorgb(__c);
               tmp:= (_c shr 16)+
                     ((_c shr 8) and $00FF)+
                     (_c and $0000FF);
               if tmp>550 then bmp1.canvas.pixels[x,y]:=clwhite
               else
               if tmp>250 then bmp1.canvas.pixels[x,y]:=c1
               else
               if tmp>60 then bmp1.canvas.pixels[x,y]:=c2
               else bmp1.canvas.pixels[x,y]:=clblack;
               end;
        end;
end;
procedure myDrawButtonFace(Canvas: TCanvas; const Client: TRect;
  BevelWidth: Integer; IsDown:boolean;c1,c2:tcolor);
  {c1 & c2 reserved for future use}
var
  R: TRect;
  DC: THandle;
begin
  R := Client;
  with Canvas do
  begin
      Brush.Style := bsclear;
      DC := Canvas.Handle;   
      if IsDown then
      begin    { DrawEdge is faster than Polyline }
        DrawEdge(DC, R, BDR_SUNKENINNER, BF_TOPLEFT);              { black     }
        DrawEdge(DC, R, BDR_SUNKENOUTER, BF_BOTTOMRIGHT);          { btnhilite }
        Dec(R.Bottom);
        Dec(R.Right);
        Inc(R.Top);
        Inc(R.Left);
        DrawEdge(DC, R, BDR_SUNKENOUTER, BF_TOPLEFT); { btnshadow }
      end
      else
      begin
        DrawEdge(DC, R, BDR_RAISEDOUTER, BF_BOTTOMRIGHT);          { black }
        Dec(R.Bottom);
        Dec(R.Right);
        DrawEdge(DC, R, BDR_RAISEDINNER, BF_TOPLEFT);              { btnhilite }
        Inc(R.Top);
        Inc(R.Left);
        DrawEdge(DC, R, BDR_RAISEDINNER, BF_BOTTOMRIGHT); { btnshadow }
      end;
    end
end;
end.
